routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::group(['prefix' => '', 'middleware' => ['web']], function(){
    Route::get('/', ['as'=>'home', 'uses' => 'PokedexController@index']);
    Route::model('pokemon', 'App\Pokemon');
    Route::resource('pokemon', 'PokedexController')->only('index', 'show');
});

app/Pokemon.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Pokemon extends Model
{
    protected $fillable = [
        'name',
        'base_experience',
        'height',
        'is_default',
        'order',
        'weight',
        'location_area_encounters',
        'species'
    ];
    
    public function sprites(){
        return $this->hasOne('App\PokemonSprite');
    }

    public function abilities(){
        return $this->hasMany('App\PokemonAbility')->orderby('slot', 'ASC');
    }
}

app/PokemonAbility.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class PokemonAbility extends Model
{
    protected $fillable = [
        'pokemon_id',
        'name',
        'slot',
        'is_hidden'
    ];

    public function pokemon(){
        return $this->belongsTo('App\Pokemon');
    }
}

app/PokemonSprite.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class PokemonSprite extends Model
{
    protected $fillable = [
        'pokemon_id',
        'front_default',	
        'front_shiny',	
        'front_female',	
        'front_shiny_female',
        'back_default',	
        'back_shiny',	
        'back_female',	        
        'back_shiny_female',
    ];

    public function pokemon(){
        return $this->belongsTo('App\Pokemon');
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/PokedexController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Pokemon;
use Illuminate\Support\Collection;
use CollectionPaginator;

class PokedexController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $pokemon = Pokemon::where(function($query) use ($request){
            if(!empty($request->s))
                $query->where('name', 'like', $request->s);
        })->get();

        $pokemon = (isset($pokemon) && !empty($pokemon) && $pokemon->count() > 0) ? CollectionPaginator::paginate($pokemon, 20) : CollectionPaginator::paginate(new Collection(), 20);
        return view('index', [
            'pokemon' => $pokemon,
            's' => $request->get('s')
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Pokemon $pokemon)
    {
        return view('show', [
            'pokemon' => $pokemon
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/includes/flash.blade.php
@if( !empty( request()->session()->exists('success') ) )
    <div class="alert alert-success alert-dismissable fade in">
        <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
        {{ request()->session()->get('success') }}
    </div>
@endif
@if( !empty( request()->session()->exists('message') ) )
    <div class="alert alert-info alert-dismissable fade in">
        <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
        {{ request()->session()->get('message') }}
    </div>
@endif
@if( !empty( request()->session()->exists('warning') ) )
    <div class="alert alert-warning alert-dismissable fade in">
        <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
        {{ request()->session()->get('warning') }}
    </div>
@endif
@if( !empty( request()->session()->exists('error') ) )
    <div class="alert alert-danger alert-dismissable fade in">
        <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
        {{ request()->session()->get('error') }}
    </div>
@endif

resources/views/includes/footer.blade.php
<!-- footer content -->
<footer>
    <div class="pull-right">
        {{ config('app.name') }} &copy; {{date('Y')}}
    </div>
    <div class="clearfix"></div>
</footer>
<!-- /footer content -->

resources/views/includes/sidebar.blade.php
<div class="col-md-3 left_col">
    <div class="left_col scroll-view">        
        <!-- menu profile quick info -->
        <div class="profile clearfix">
            <div class="profile_pic">
                <img src="{{ Gravatar::src('martin.vernon@gmail.com') }}" alt="Avatar of Martin Vernon" class="img-circle profile_img">
            </div>
            <div class="profile_info">
                <span>Welcome,</span>
                <h2>Martin Vernon</h2>
            </div>
        </div>
        <!-- /menu profile quick info -->
        
        <!-- sidebar menu -->
        <div id="sidebar-menu" class="main_menu_side hidden-print main_menu">
            <div class="menu_section">
                <ul class="nav side-menu">
                    <li>
                        <a>
                            {{ HTML::image('images/small-logo.png', config('app.name'), ['height'=>'37px', 'width'=>'37px']) }}
                            <span class="menu-label">Pokedex</span><span class="fas fa-chevron-down "></span>
                        </a>
                        <ul class="nav child_menu" style="display:none;">
                            <li>
                                <a href="{{route('pokemon.index')}}"> All Pokemon</a>
                            </li>
                        </ul>
                    </li>
                </ul>
            </div>
        </div>
        <!-- /sidebar menu -->
    </div>
</div>

resources/views/includes/topbar.blade.php
<!-- top navigation -->
<div class="top_nav clearfix">
    <div class="nav_menu">
        <nav>
            <div class="nav toggle">
                <a id="menu_toggle"><i class="fas fa-bars"></i></a>
            </div>
        </nav>
    </div>
</div>
<!-- /top navigation -->

resources/views/index.blade.php
@extends('layouts.blank', [
    'main_title' => 'Pokedex',
    'search_route' => 'pokemon.index'
])

@push('stylesheets')
@endpush

@section('main_container')
    <div id="innerWrap">
        <div id="pageInner">
            <div class="row">
                <div class="col-md-12 col-sm-12 col-xs-12">
                    <div class="x_panel">
                        <div class="x_title">
                            <h2>
                                All Pokemon
                            </h2>
                            <div class="clearfix"></div>
                        </div>
                        <div class="x_content">
                            <div class="table-responsive">
                                <table class="table table-striped jambo_table bulk_action">
                                    <thead>
                                        <tr class="headings">
                                            <th class="column-title">Name</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @if(isset($pokemon) && !empty($pokemon) && sizeof($pokemon) > 0 )
                                            @foreach($pokemon as $poke)
                                                <tr>
                                                    <td>
                                                        <a href="{{route('pokemon.show', $poke)}}" title="{{$poke->name}}">
                                                            @if(!empty($poke->sprites))<img src="{{$poke->sprites->front_default}}" />@endif
                                                            {{ucfirst($poke->name)}}
                                                        </a>
                                                    </td>
                                                </tr>
                                            @endforeach
                                        @elseif( !empty($s) )
                                            <tr>
                                                <td class="text-center empty">There are no Pokemon found with your search term <strong><i>{{$s}}</i></strong>. Please search again.</td>
                                            </tr>
                                        @else
                                            <tr>
                                                <td class="text-center empty">There are no Pokemon available</td>
                                            </tr>
                                        @endif
                                    </tbody>
                                </table>
                                {{ $pokemon->links() }}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@push('scripts')
@endpush

resources/views/layouts/blank.blade.php
<!DOCTYPE html>
<html lang="en">

    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

        <!-- Meta, title, CSS, favicons, etc. -->
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="csrf-token" content="{{ csrf_token() }}">


        <title>{{ config('app.name') }}</title>

        <!-- App Style -->
        {{ Html::style(mix('css/app.css')) }}
        <!-- Blade Styles -->
        @stack('stylesheets')

    </head>

    <body class="nav-sm">
        <div id="app" class="container body">
            <div class="main_container">

                @include('includes/sidebar')

                @include('includes/topbar')

                <div class="right_col" role="main">
                    @if( !empty($main_title) )
                        <div class="page-title clearfix">
                            <div class="title_left">
                                <h3>{{ $main_title }}</h3>
                            </div>

                            @if( !empty($search_route) )
                                <div class="title_right">
                                    {!! Form::searchfrm( $search_route, 'col-md-5 col-sm-5 col-xs-12 form-group pull-right top_search', !empty($search_append) ? $search_append : null ) !!}
                                </div>
                            @endif
                        </div>
                    @endif

                    @include('includes/flash')
                        <div id="parsley_error_div" class="alert alert-danger alert-dismissable fade in" style="display: none">
                            <a href="#" class="close" id="parsley_error_close" >&times;</a>
                            <span id="parsley_error_msg"> There was an error with your form submission, please review below.</span>
                        </div>

                    @yield('main_container')

                </div>

                @include('includes/footer')
            </div>
        </div>

        <!-- App Scripts -->
        {{ Html::script(mix('js/app.js')) }}

        <!-- Blade Scripts -->
        @stack('scripts')
        <script>
            $('#parsley_error_close').on('click', function () {
                $('#parsley_error_div').hide();
            });
            window.Parsley.on('field:error', function() {
                // This global callback will be called for any field that fails validation.
                $('#parsley_error_div').show();
            });
        </script>
    </body>
</html>

resources/views/show.blade.php
@extends('layouts.blank', [])

@push('stylesheets')
@endpush

@section('main_container')
    <div id="innerWrap">
        <div id="pageInner">
            <div class="row">
                <div class="col-md-12 col-sm-12 col-xs-12">
                    <div class="x_panel">
                        <div class="x_title">
                            <h2>
                                {{ucfirst($pokemon->name)}}
                            </h2>
                            <div class="clearfix"></div>
                        </div>
                        <div class="x_content">
                            <div class="table-responsive">
                                <table class="table table-striped jambo_table bulk_action">
                                    <tbody>
                                        <tr>
                                            <td>Base Experiance</td>
                                            <td colspan="8">{{$pokemon->base_experience}}</td>
                                        </tr>
                                        <tr>
                                            <td>Species</td>
                                            <td colspan="8">{{ucfirst($pokemon->species)}}</td>
                                        </tr>
                                        <tr>
                                            <td>Height</td>
                                            <td colspan="8">{{$pokemon->height}}</td>
                                        </tr>
                                        <tr>
                                            <td>Weight</td>
                                            <td colspan="8">{{$pokemon->weight}}</td>
                                        </tr>
                                        <tr>
                                            <td>Sprites</td>
                                            <td>
                                                <strong>Front</strong><br/>
                                                @if(!empty($pokemon->sprites) && isset($pokemon->sprites->front_default))<img src="{{$pokemon->sprites->front_default}}" />@else Image not found @endif
                                            </td>
                                            <td>
                                                <strong>Front Shiny</strong><br/>
                                                @if(!empty($pokemon->sprites) && isset($pokemon->sprites->front_shiny))<img src="{{$pokemon->sprites->front_shiny}}" />@else Image not found @endif
                                            </td>
                                            <td>
                                                <strong>Front Female</strong><br/>
                                                @if(!empty($pokemon->sprites) && isset($pokemon->sprites->front_female))<img src="{{$pokemon->sprites->front_female}}" />@else Image not found @endif
                                            </td>
                                            <td>
                                                <strong>Front Female Shiny</strong><br/>
                                                @if(!empty($pokemon->sprites) && isset($pokemon->sprites->front_shiny_female))<img src="{{$pokemon->sprites->front_shiny_female}}" />@else Image not found @endif
                                            </td>
                                            <td>
                                                <strong>Back</strong><br/>
                                                @if(!empty($pokemon->sprites) && isset($pokemon->sprites->back_default))<img src="{{$pokemon->sprites->back_default}}" />@else Image not found @endif
                                            </td>
                                            <td>
                                                <strong>Back Shiney</strong><br/>
                                                @if(!empty($pokemon->sprites) && isset($pokemon->sprites->back_shiny))<img src="{{$pokemon->sprites->back_shiny}}" />@else Image not found @endif
                                            </td>
                                            <td>
                                                <strong>Back Female</strong><br/>
                                                @if(!empty($pokemon->sprites) && isset($pokemon->sprites->back_female))<img src="{{$pokemon->sprites->back_female}}" />@else Image not found @endif
                                            </td>
                                            <td>
                                                <strong>Back Female Shiney</strong><br/>
                                                @if(!empty($pokemon->sprites) && isset($pokemon->sprites->back_shiny_female))<img src="{{$pokemon->sprites->back_shiny_female}}" />@else Image not found @endif
                                            </td>
                                        </tr>
                                        <tr>
                                            <td>Abilities</td>
                                            <td colspan="8">
                                                <table class="table table-striped jambo_table bulk_action">
                                                    <thead>
                                                        <tr class="headings">
                                                            <th class="column-title">Name</th>
                                                            <th class="column-title">Slot</th>
                                                            <th class="column-title">Is Hidden</th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                    @foreach($pokemon->abilities as $ability)
                                                        <tr>
                                                            <td>{{ucfirst($ability->name)}}</td>
                                                            <td>{{$ability->slot}}</td>
                                                            <td>@if($ability->is_hidden) True @else False @endif</td>
                                                        </tr>
                                                    @endforeach
                                                    </tbody>
                                                </table>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                            <div class="form-group">
                                <div class="col-md-12 col-sm-12 col-xs-12 text-right">
                                    <a href="{{route('pokemon.index')}}" class="btn btn-primary" data-toggle="tooltip" data-placement="left" data-original-title="Back to All Pokemon.">Back to All Pokemon</a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@push('scripts')
@endpush